<?php
/**
 * $Horde: mimp/folders.php,v 1.32 2005/01/03 14:35:16 jan Exp $
 *
 * Copyright 2000-2005 Charles J. Hagenbuch <chuck@horde.org>
 * Copyright 2000-2005 Jon Parise <jon@horde.org>
 * Copyright 2000-2005 Anil Madhavapeddy <avsm@horde.org>
 * Copyright 2003-2005 Michael Slusarz <slusarz@bigworm.colorado.edu>
 *
 * See the enclosed file COPYING for license information (GPL).  If you
 * did not receive this file, see http://www.fsf.org/copyleft/gpl.html.
 */

$authentication = OP_HALFOPEN;
@define('MIMP_BASE', dirname(__FILE__));
require_once MIMP_BASE . '/lib/base.php';
require_once MIMP_BASE . '/lib/IMAP/Tree.php';

/* Redirect back to the mailbox if folder use is not allowed. */
if (!$conf['user']['allow_folders']) {
    header('Location: ' . Horde::applicationUrl('mailbox.php', true));
    exit;
}

$title = _("Folders");
$m->set('title', $title);

$c = &$m->add(new Horde_Mobile_card('m', $title));
$c->softkey('#o', _("Menu"));
$l->setMobileObject($c);

$notification->notify(array('listeners' => 'status'));

$name_url = Horde::applicationUrl('mailbox.php');
$null = null;
$fb = &$c->add(new Horde_Mobile_block($null));

/* Initialize the IMP_Tree object. */
$mimptree = &MIMP_Tree::singleton(true, $prefs->getValue('subscribe') ? IMAPTREE_INIT_SUB : IMAPTREE_INIT_UNSUB);

/* Start iterating through the list of mailboxes, displaying them. */
$mailbox = $mimptree->reset();
do {
    $msgs_info = $row = array();
    $new = '';
    $link = null;

    if (!$mimptree->isContainer($mailbox)) {
        $link = Util::addParameter($name_url, 'mailbox', $mailbox['value']);
    }
    $name = &new Horde_Mobile_link($mailbox['label'], $link);

    $indent_level = $mailbox['level'];

    /* If we have a folder prefix, shift each folder in the hierarchy up
     * one level before showing it to the user. */
    if (!empty($prefix) && ($mailbox['value'] != 'INBOX')) {
        $indent_level--;
    }

    if ($indent_level >= 0) {
        /* Display the folder. */
        $fb->add(new Horde_Mobile_text(str_repeat('..', $indent_level)));
        $fb->add($name);
        if (!empty($new)) {
            $fb->add(new Horde_Mobile_text($new, array('b')));
        }
        $t = &$fb->add(new Horde_Mobile_text("\n"));
        $t->set('linebreaks', true);
    }
} while (($mailbox = $mimptree->next()));

$menu = &new Horde_Mobile_card('o', _("Menu"));
$mset = &$menu->add(new Horde_Mobile_linkset());
$mset->add(new Horde_Mobile_link(_("Refresh"), Horde::selfUrl(), _("Refresh")));
MIMP::addMIMPMenu($mset);
$m->add($menu);

$m->display();
