<?php
/**
 * MIMP external API interface.
 *
 * This file defines MIMP's external API interface. Other applications
 * can interact with MIMP through this API.
 *
 * $Horde: mimp/lib/api.php,v 1.1 2004/04/14 20:40:59 chuck Exp $
 *
 * See the enclosed file COPYING for license information (GPL). If you
 * did not receive this file, see http://www.fsf.org/copyleft/gpl.html.
 *
 * @package MIMP
 */

$_services['authenticate'] = array(
    'args' => array('userID', 'credentials', 'params'),
    'type' => 'boolean'
);


/**
 * TODO
 *
 * @param string $userID       TODO
 * @param array  $credentials  TODO
 * @param array  $params       TODO
 *
 * @return boolean  Whether MIMP authentication was successful.
 */
function _mimp_authenticate($userID, $credentials, $params)
{
    $authentication = 'none';
    require_once dirname(__FILE__) . '/base.php';

    if (!empty($params['server'])) {
        $server = $params['server'];
    } else {
        require_once MIMP_BASE . '/config/servers.php';
        foreach ($servers as $key => $curServer) {
            if (!isset($server) && substr($key, 0, 1) != '_') {
                $server = $key;
            }
            if (MIMP::isPreferredServer($curServer, $key)) {
                $server = $key;
                break;
            }
        }
    }

    require_once MIMP_BASE . '/lib/Session.php';
    if (MIMP_Session::createSession($userID, $credentials['password'], $server)) {
        global $mimp;
        $entry = sprintf('Login success for %s [%s] to {%s:%s}', $mimp['uniquser'], $_SERVER['REMOTE_ADDR'], $mimp['server'], $mimp['port']);
        Horde::logMessage($entry, __FILE__, __LINE__, PEAR_LOG_NOTICE);
        return true;
    }

    return false;
}
